QCPAxisTickerFixed Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Protected Functions
QCPAxisTickerFixed Class Reference

Specialized axis ticker with a fixed tick step. More...

Inheritance diagram for QCPAxisTickerFixed:

## Public Types
enum | ScaleStrategy
Public Types inherited from QCPAxisTicker
enum | TickStepStrategy

## Public Functions
| QCPAxisTickerFixed ()
double | tickStep () const
ScaleStrategy | scaleStrategy () const
void | setTickStep (double step)
void | setScaleStrategy (ScaleStrategy strategy)
Public Functions inherited from QCPAxisTicker
| QCPAxisTicker ()
TickStepStrategy | tickStepStrategy () const
int | tickCount () const
double | tickOrigin () const
void | setTickStepStrategy (TickStepStrategy strategy)
void | setTickCount (int count)
void | setTickOrigin (double origin)
virtual void | generate (const QCPRange &range, const QLocale &locale, QChar formatChar, int precision, QVector< double > &ticks, QVector< double > *subTicks, QVector< QString > *tickLabels)

## Protected Functions
virtual double | getTickStep (const QCPRange &range)
Protected Functions inherited from QCPAxisTicker
virtual double | getTickStep (const QCPRange &range)
virtual int | getSubTickCount (double tickStep)
virtual QString | getTickLabel (double tick, const QLocale &locale, QChar formatChar, int precision)
virtual QVector< double > | createTickVector (double tickStep, const QCPRange &range)
virtual QVector< double > | createSubTickVector (int subTickCount, const QVector< double > &ticks)
virtual QVector< QString > | createLabelVector (const QVector< double > &ticks, const QLocale &locale, QChar formatChar, int precision)
void | trimTicks (const QCPRange &range, QVector< double > &ticks, bool keepOneOutlier) const
double | pickClosest (double target, const QVector< double > &candidates) const
double | getMantissa (double input, double *magnitude=nullptr) const
double | cleanMantissa (double input) const

## Detailed Description

Specialized axis ticker with a fixed tick step.

This QCPAxisTicker subclass generates ticks with a fixed tick step set with setTickStep. It is also possible to allow integer multiples and integer powers of the specified tick step with setScaleStrategy.

A typical application of this ticker is to make an axis only display integers, by setting the tick step of the ticker to 1.0 and the scale strategy to ssMultiples.

Another case is when a certain number has a special meaning and axis ticks should only appear at multiples of that value. In this case you might also want to consider QCPAxisTickerPi because despite the name it is not limited to only pi symbols/values.

The ticker can be created and assigned to an axis like this:

QSharedPointer<QCPAxisTickerFixed> fixedTicker(new QCPAxisTickerFixed);
customPlot->xAxis->setTicker(fixedTicker);
fixedTicker->setTickStep(1.0); // tick step shall be 1.0
fixedTicker->setScaleStrategy(QCPAxisTickerFixed::ssNone); // and no scaling of the tickstep (like multiples or powers) is allowed
QCPAxisTickerFixed
Specialized axis ticker with a fixed tick step.
Definition: axistickerfixed.h:32
QCPAxisTickerFixed::ssNone
@ ssNone
Modifications are not allowed, the specified tick step is absolutely fixed. This might cause a high t...
Definition: axistickerfixed.h:41

## Member Enumeration Documentation

## ◆ ScaleStrategy

enum QCPAxisTickerFixed::ScaleStrategy

Defines how the axis ticker may modify the specified tick step (setTickStep) in order to control the number of ticks in the axis range.

See also
  setScaleStrategy

Enumerator
ssNone | Modifications are not allowed, the specified tick step is absolutely fixed. This might cause a high tick density and overlapping labels if the axis range is zoomed out.
ssMultiples | An integer multiple of the specified tick step is allowed. The used factor follows the base class properties of setTickStepStrategy and setTickCount.
ssPowers | An integer power of the specified tick step is allowed.

## Constructor & Destructor Documentation

## ◆ QCPAxisTickerFixed()

QCPAxisTickerFixed::QCPAxisTickerFixed | ( |  | ) |

Constructs the ticker and sets reasonable default values. Axis tickers are commonly created managed by a QSharedPointer, which then can be passed to QCPAxis::setTicker.

## Member Function Documentation

## ◆ setTickStep()

void QCPAxisTickerFixed::setTickStep | ( | double | step | ) |

Sets the fixed tick interval to step.

The axis ticker will only use this tick step when generating axis ticks. This might cause a very high tick density and overlapping labels if the axis range is zoomed out. Using setScaleStrategy it is possible to relax the fixed step and also allow multiples or powers of step. This will enable the ticker to reduce the number of ticks to a reasonable amount (see setTickCount).

## ◆ setScaleStrategy()

void QCPAxisTickerFixed::setScaleStrategy | ( | QCPAxisTickerFixed::ScaleStrategy | strategy | ) |

Sets whether the specified tick step (setTickStep) is absolutely fixed or whether modifications may be applied to it before calculating the finally used tick step, such as permitting multiples or powers. See ScaleStrategy for details.

The default strategy is ssNone, which means the tick step is absolutely fixed.

## ◆ getTickStep()

double QCPAxisTickerFixed::getTickStep | ( | const QCPRange & | range | ) |
| protectedvirtual

Determines the actually used tick step from the specified tick step and scale strategy (setTickStep, setScaleStrategy).

This method either returns the specified tick step exactly, or, if the scale strategy is not ssNone, a modification of it to allow varying the number of ticks in the current axis range.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

The documentation for this class was generated from the following files:

- src/axis/axistickerfixed.h
- src/axis/axistickerfixed.cpp